///
/// @file
/// @details An entity within the LudumDare36 project.
///
/// <!-- Copyright (c) 2016 Tim Beaudet - All Rights Reserved -->
///-----------------------------------------------------------------------------------------------------------------///

#include "card_entity.h"

//--------------------------------------------------------------------------------------------------------------------//

//const LudumDare36::PunchCardTransform LudumDare36::CardEntity::kDeckTransform(tbMath::Vector2(80.0f, 640.0f), -25.0f, 0.5f);
//const LudumDare36::PunchCardTransform LudumDare36::CardEntity::kDiscardTransform(tbMath::Vector2(1200.0f, 640.0f), 25.0f, 0.5f);
//const LudumDare36::PunchCardTransform LudumDare36::CardEntity::kHandTransform[] = {
//	LudumDare36::PunchCardTransform(tbMath::Vector2(640.0f - 402.5f, 570.0f), 0.0f, 0.75f),
//	LudumDare36::PunchCardTransform(tbMath::Vector2(640.0f - 287.5f, 570.0f), 0.0f, 0.75f),
//	LudumDare36::PunchCardTransform(tbMath::Vector2(640.0f - 172.5f, 570.0f), 0.0f, 0.75f),
//	LudumDare36::PunchCardTransform(tbMath::Vector2(640.0f - 57.5f, 570.0f), 0.0f, 0.75f),
//	LudumDare36::PunchCardTransform(tbMath::Vector2(640.0f + 57.5f, 570.0f), 0.0f, 0.75f),
//	LudumDare36::PunchCardTransform(tbMath::Vector2(640.0f + 172.5f, 570.0f), 0.0f, 0.75f),
//	LudumDare36::PunchCardTransform(tbMath::Vector2(640.0f + 287.5f, 570.0f), 0.0f, 0.75f),
//	LudumDare36::PunchCardTransform(tbMath::Vector2(640.0f + 402.5f, 570.0f), 0.0f, 0.75f),
//};
//const LudumDare36::PunchCardTransform LudumDare36::CardEntity::kSlotTransform[] = {
//	LudumDare36::PunchCardTransform(tbMath::Vector2(640.0f - 106.0f, 420.0f), 0.0f, 0.35f),
//	LudumDare36::PunchCardTransform(tbMath::Vector2(640.0f - 53.0f, 420.0f), 0.0f, 0.35f),
//	LudumDare36::PunchCardTransform(tbMath::Vector2(640.0f + 0.0f, 420.0f), 0.0f, 0.35f),
//	LudumDare36::PunchCardTransform(tbMath::Vector2(640.0f + 53.0f, 420.0f), 0.0f, 0.35f),
//	LudumDare36::PunchCardTransform(tbMath::Vector2(640.0f + 106.0f, 420.0f), 0.0f, 0.35f),
//};

const LudumDare36::PunchCardTransform LudumDare36::SlidingCardEntity::kDeckTransform(tbMath::Vector2(80.0f, 640.0f), -25.0f, 0.45f);
const LudumDare36::PunchCardTransform LudumDare36::SlidingCardEntity::kDiscardTransform(tbMath::Vector2(1200.0f, 640.0f), 25.0f, 0.45f);
const LudumDare36::PunchCardTransform LudumDare36::SlidingCardEntity::kRobotPlanTransform(tbMath::Vector2(640.0f, 620.0f), 0.0f, 0.85f);
const LudumDare36::PunchCardTransform LudumDare36::SlidingCardEntity::kShuffleDeckTransform1(tbMath::Vector2(540.0f, 240.0f), -45.0f, 0.85f);
const LudumDare36::PunchCardTransform LudumDare36::SlidingCardEntity::kShuffleDeckTransform2(tbMath::Vector2(740.0f, 240.0f), 45.0f, 0.85f);

const LudumDare36::PunchCardTransform LudumDare36::SlidingCardEntity::kHandTransform[] = {
	LudumDare36::PunchCardTransform(tbMath::Vector2(640.0f - 322.0f, 620.0f), 0.0f, 0.6f),
	LudumDare36::PunchCardTransform(tbMath::Vector2(640.0f - 230.0f, 620.0f), 0.0f, 0.6f),
	LudumDare36::PunchCardTransform(tbMath::Vector2(640.0f - 138.0f, 620.0f), 0.0f, 0.6f),
	LudumDare36::PunchCardTransform(tbMath::Vector2(640.0f - 46.0f, 620.0f), 0.0f, 0.6f),
	LudumDare36::PunchCardTransform(tbMath::Vector2(640.0f + 46.0f, 620.0f), 0.0f, 0.6f),
	LudumDare36::PunchCardTransform(tbMath::Vector2(640.0f + 138.0f, 620.0f), 0.0f, 0.6f),
	LudumDare36::PunchCardTransform(tbMath::Vector2(640.0f + 230.0f, 620.0f), 0.0f, 0.6f),
	LudumDare36::PunchCardTransform(tbMath::Vector2(640.0f + 322.0f, 620.0f), 0.0f, 0.60f),
};
const LudumDare36::PunchCardTransform LudumDare36::SlidingCardEntity::kSlotTransform[] = {
	LudumDare36::PunchCardTransform(tbMath::Vector2(640.0f - 106.0f, 50.0f), 0.0f, 0.35f),
	LudumDare36::PunchCardTransform(tbMath::Vector2(640.0f - 53.0f, 50.0f), 0.0f, 0.35f),
	LudumDare36::PunchCardTransform(tbMath::Vector2(640.0f + 0.0f, 50.0f), 0.0f, 0.35f),
	LudumDare36::PunchCardTransform(tbMath::Vector2(640.0f + 53.0f, 50.0f), 0.0f, 0.35f),
	LudumDare36::PunchCardTransform(tbMath::Vector2(640.0f + 106.0f, 50.0f), 0.0f, 0.35f),
};

//--------------------------------------------------------------------------------------------------------------------//

LudumDare36::SlidingCardEntity::SlidingCardEntity(const PunchCard& punchCard, const PunchCardTransform& start, const PunchCardTransform& final,
	const tbGame::GameTimer& slideTimer) :
	tbGame::Entity("SlidingCardEntity"),
	mSprite(GetSpriteForCard(punchCard)),
	mPunchCard(punchCard),
	mStartTransform(start),
	mFinalTransform(final),
	mInitialTimer(slideTimer),
	mSlideTimer(slideTimer)
{
	AddGraphic(mSprite);
}

//--------------------------------------------------------------------------------------------------------------------//

LudumDare36::SlidingCardEntity::~SlidingCardEntity(void)
{
}

//--------------------------------------------------------------------------------------------------------------------//

void LudumDare36::SlidingCardEntity::OnAdded(void)
{
	tbGame::Entity::OnAdded();
}

//--------------------------------------------------------------------------------------------------------------------//

void LudumDare36::SlidingCardEntity::OnRemoved(void)
{
	tbGame::Entity::OnRemoved();
}

//--------------------------------------------------------------------------------------------------------------------//

void LudumDare36::SlidingCardEntity::OnSimulate(void)
{
	tbGame::Entity::OnSimulate();


}

//--------------------------------------------------------------------------------------------------------------------//

void LudumDare36::SlidingCardEntity::OnUpdate(const float deltaTime)
{
	tbGame::Entity::OnUpdate(deltaTime);
}

//--------------------------------------------------------------------------------------------------------------------//

void LudumDare36::SlidingCardEntity::OnRender(void) const
{
	tbGame::Entity::OnRender();
}

//--------------------------------------------------------------------------------------------------------------------//

tbGraphics::Sprite LudumDare36::SlidingCardEntity::GetSpriteForCard(const PunchCard& punchCard)
{
	tbCore::tbString cardName("punch_card_face_down");

	switch (punchCard)
	{
	default:
	case PunchCard::kFaceDown: cardName = "punch_card_face_down"; break;
	case PunchCard::kDeckPile: cardName = "punch_card_deck"; break;
	case PunchCard::kDiscardPile: cardName = "punch_card_discard"; break;
	case PunchCard::kEmptyPile: cardName = "punch_card_empty"; break;

	case PunchCard::kDelayTurn: cardName = "punch_card_delay"; break;
	case PunchCard::kTurn90Left: cardName = "punch_card_turn_left"; break;
	case PunchCard::kTurn90Right: cardName = "punch_card_turn_right"; break;
	case PunchCard::kTurn180: cardName = "punch_card_turn_180"; break;
	case PunchCard::kMoveForward1: cardName = "punch_card_forward_1"; break;
	case PunchCard::kMoveForward2: cardName = "punch_card_forward_2"; break;
	case PunchCard::kMoveBackward1: cardName = "punch_card_backward_1"; break;
	case PunchCard::kMoveBackward2: cardName = "punch_card_backward_2"; break;
	};

	return tbGraphics::Sprite("punch_card_sheet", cardName);
}

//--------------------------------------------------------------------------------------------------------------------//

void LudumDare36::SlidingCardEntity::RenderCard(const PunchCard& punchCard, const PunchCardTransform& transform)
{
	tbGraphics::Sprite& cardSprite = GetSpriteForCard(punchCard);
	cardSprite.SetOrigin(tbGraphics::kAnchorCenter);
	cardSprite.SetPosition(transform.mPosition);
	cardSprite.SetRotation(transform.mOrientation);
	cardSprite.SetScale(transform.mScale.x, transform.mScale.y);
	cardSprite.SetScroll(0.0f);
	cardSprite.SetDepth(0.1f);
	cardSprite.Render();
}

//--------------------------------------------------------------------------------------------------------------------//

bool LudumDare36::SlidingCardEntity::IsPointContained(const tbMath::Vector2& point, const PunchCardTransform& transform)
{
	tb_error_if(false == tbMath::IsZero(transform.mOrientation), "Error: Expected to collide point with card transform having no rotation.");

	const float halfWidth(150.0f / 2.0f * transform.mScale.x);
	const float halfHeight(225.0f / 2.0f * transform.mScale.y);

	if (point.x < transform.mPosition.x - halfWidth) { return false; }
	if (point.x > transform.mPosition.x + halfWidth) { return false; }
	if (point.y < transform.mPosition.y - halfHeight) { return false; }
	if (point.y > transform.mPosition.y + halfHeight) { return false; }

	return true;
}

//--------------------------------------------------------------------------------------------------------------------//

void LudumDare36::SlidingCardEntity::OnCollideWith(tbGame::Entity& otherEntity)
{
	tbGame::Entity::OnCollideWith(otherEntity);
}

//--------------------------------------------------------------------------------------------------------------------//
