///
/// @file
/// @details An entity within the LudumDare36 project.
///
/// <!-- Copyright (c) 2016 Tim Beaudet - All Rights Reserved -->
///-----------------------------------------------------------------------------------------------------------------///

#ifndef _LudumDare36_ConfirmPlanEntity_h_
#define _LudumDare36_ConfirmPlanEntity_h_

#include "ludumdare36.h"

namespace LudumDare36
{
	class GameplayScene;

	class ConfirmPlanEntity : public tbGame::Entity
	{
	public:
		ConfirmPlanEntity(GameplayScene& gameplayScene);
		ConfirmPlanEntity(GameplayScene& gameplayScene, bool reallyWinBox);
		virtual ~ConfirmPlanEntity(void);

		void HideButton(bool immediate = false);
		void ShowButton(void);
		void CancelDoInput(void) { mDoInput = false; }

	protected:
		virtual void OnSimulate(void) override;
		virtual void OnUpdate(const float deltaTime) override;

	private:
		GameplayScene& mGameplayScene;

		bool mIsWinOrLoseBox;
		bool mSlidingIn;
		bool mDoInput;
		float wave;
		tbGame::GameTimer mSlideTimer;
		tbGraphics::Sprite mSprite;
	};

}; /* namespace LudumDare36 */

#endif /* _LudumDare36_ConfirmPlanEntity_h_ */
