///
/// @file
/// @details An entity within the LudumDare36 project.
///
/// <!-- Copyright (c) 2016 Tim Beaudet - All Rights Reserved -->
///-----------------------------------------------------------------------------------------------------------------///

#ifndef _LudumDare36_ScoreDisplay_h_
#define _LudumDare36_ScoreDisplay_h_

#include "ludumdare36.h"

namespace LudumDare36
{

	class ScoreDisplay : public tbGame::Entity
	{
	public:
		ScoreDisplay(void);
		virtual ~ScoreDisplay(void);

	protected:
		virtual void OnAdded(void) override;
		virtual void OnRemoved(void) override;
		virtual void OnSimulate(void) override;
		virtual void OnUpdate(const float deltaTime) override;
		virtual void OnRender(void) const override;
		virtual void OnCollideWith(tbGame::Entity& otherEntity) override;

	private:
		tbGraphics::Text mScoreText;
		tbGraphics::Text mBestScoreText;
	};

}; /* namespace LudumDare36 */

#endif /* _LudumDare36_ScoreDisplay_h_ */
