///
/// @file
/// @details This scene is the gameplay scene for the LudumDare36 project.
///
/// <!-- Copyright (c) 2016 Tim Beaudet - All Rights Reserved -->
///-----------------------------------------------------------------------------------------------------------------///

#ifndef _LudumDare36_SplashScene_h_
#define _LudumDare36_SplashScene_h_

#include "ludumdare36.h"

namespace LudumDare36
{

	class SplashScene : public tbGame::GameScene
	{
	public:
		SplashScene(void);
		virtual ~SplashScene(void);

		virtual void OnSimulate(void) override;
		virtual void OnUpdate(const float deltaTime) override;
		virtual void OnRender(void) const override;
		virtual void OnOpen(void) override;
		virtual void OnClose(void) override;

	protected:

	private:
		tbGraphics::Sprite mBlackbirdLogo;

		tbGame::GameTimer mSceneTimer;
		tbGame::InputAction mJumpToGameAction;
	};


	class TitleScene : public tbGame::GameScene
	{
	public:
		TitleScene(void);
		virtual ~TitleScene(void);

	protected:
		virtual void OnSimulate(void) override;
		virtual void OnOpen(void) override;

	private:
		tbGraphics::Sprite mTitleScreen;
		tbGame::GameTimer mFadeInTimer;
		tbGame::GameTimer mFadeOutTimer;
		tbGame::InputAction mStartGameAction;
	};


}; /* namespace LudumDare36 */

#endif /* _LudumDare36_SplashScene_h_ */
