///
/// @file
/// @details An entity within the LudumDare36 project.
///
/// <!-- Copyright (c) 2016 Tim Beaudet - All Rights Reserved -->
///-----------------------------------------------------------------------------------------------------------------///

#ifndef _LudumDare36_TemplateEntity_h_
#define _LudumDare36_TemplateEntity_h_

#include "ludumdare36.h"

namespace LudumDare36
{

	class TemplateEntity : public tbGame::Entity
	{
	public:
		TemplateEntity(void);
		virtual ~TemplateEntity(void);

	protected:
		virtual void OnAdded(void) override;
		virtual void OnRemoved(void) override;
		virtual void OnSimulate(void) override;
		virtual void OnUpdate(const float deltaTime) override;
		virtual void OnRender(void) const override;
		virtual void OnCollideWith(tbGame::Entity& otherEntity) override;

	private:
		tbGraphics::Sprite mSprite;
	};

}; /* namespace LudumDare36 */

#endif /* _LudumDare36_TemplateEntity_h_ */
