///
/// @file
/// @details This scene is the gameplay scene for the LudumDare36 project.
///
/// <!-- Copyright (c) 2016 Tim Beaudet - All Rights Reserved -->
///-----------------------------------------------------------------------------------------------------------------///

#include "win_game_scene.h"
#include "scene_manager.h"

#include "turtle_brains\graphics\implementation\tbi_renderer.h"

bool LudumDare36::WinGameScene::sWinResult(false);

//--------------------------------------------------------------------------------------------------------------------//

LudumDare36::WinGameScene::WinGameScene(void)
{
	mQuitGameAction.AddBinding(tbApplication::tbKeyEscape);
}

//--------------------------------------------------------------------------------------------------------------------//

LudumDare36::WinGameScene::~WinGameScene(void)
{
}

//--------------------------------------------------------------------------------------------------------------------//

void LudumDare36::WinGameScene::OnSimulate(void)
{
	tbGame::GameScene::OnSimulate();

	if (true == mQuitGameAction.IsReleased())
	{	//This should be the very last check to happen as game ends immediately.
		theSceneManager->QuitGame();
	}	
}

//--------------------------------------------------------------------------------------------------------------------//

void LudumDare36::WinGameScene::OnUpdate(const float deltaTime)
{
	tbGame::GameScene::OnUpdate(deltaTime);
}

//--------------------------------------------------------------------------------------------------------------------//

void LudumDare36::WinGameScene::OnRender(void) const
{
	if (true == sWinResult)
	{
		glClearColor(0.0f, 1.0f, 0.0f, 1.0f);
	}
	else
	{
		glClearColor(1.0f, 0.0f, 0.0f, 1.0f);
	}
	glClear(GL_COLOR_BUFFER_BIT);

	tbGame::GameScene::OnRender();
}

//--------------------------------------------------------------------------------------------------------------------//

void LudumDare36::WinGameScene::OnOpen(void)
{
	tbGame::GameScene::OnOpen();
}

//--------------------------------------------------------------------------------------------------------------------//

void LudumDare36::WinGameScene::OnClose(void)
{
	tbGame::GameScene::OnClose();
}

//--------------------------------------------------------------------------------------------------------------------//
