///
/// @file
/// @details This scene is the gameplay scene for the LudumDare36 project.
///
/// <!-- Copyright (c) 2016 Tim Beaudet - All Rights Reserved -->
///-----------------------------------------------------------------------------------------------------------------///

#ifndef _LudumDare36_WinGameScene_h_
#define _LudumDare36_WinGameScene_h_

#include "ludumdare36.h"

namespace LudumDare36
{

	class WinGameScene : public tbGame::GameScene
	{
	public:
		static bool sWinResult;

		WinGameScene(void);
		virtual ~WinGameScene(void);

	protected:
		virtual void OnSimulate(void) override;
		virtual void OnUpdate(const float deltaTime) override;
		virtual void OnRender(void) const override;
		virtual void OnOpen(void) override;
		virtual void OnClose(void) override;

	private:
		tbGame::InputAction mQuitGameAction;
	};

}; /* namespace LudumDare36 */

#endif /* #define _LudumDare36_WinGameScene_h_ */
